//---------------------------------------------------------------------------
#ifndef CDViewH
#define CDViewH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ExtCtrls.hpp>
#include <Buttons.hpp>
#include <Dialogs.hpp>
#include <MPlayer.hpp>
#include <stdio.h>
#include <fstream.h>
#include <Menus.hpp>
//---------------------------------------------------------------------------
struct LabelInfo
{
  TColor BGColor;
  TFont *LFont;
  TPoint Pos;
  bool Visible;
};
//---------------------------------------------------------------------------
struct TrackInfo
{
  AnsiString Title;
  AnsiString FileName;
  char Length[6];
  int TimeLength;
};
//---------------------------------------------------------------------------
const int NumImgs = 23;
//---------------------------------------------------------------------------
class TTrackClass
{
private:
  int FCurrentTrack;
  int FNumTracks;
  TrackInfo FTracks[100];
  TMPModes FUserMode;

  void ChangeTrack(const int NewPosition, const bool AutoPlay);
public:
  TMediaPlayer *MediaPlayer;
  __property int CurrentTrack = {read=FCurrentTrack, write=FCurrentTrack};
  __property int NumTracks = {read=FNumTracks};

  __fastcall TTrackClass();
  __fastcall ~TTrackClass();
  void AddTrack(AnsiString File);
  void AddCDTrack();
  void ClearTracks();
  bool GetArrayPos();
  TrackInfo GetCurrentTrackInfo() {return FTracks[FCurrentTrack];}
  void __fastcall GetDisplayLabels(char *M1, char *M2);
  TrackInfo GetTrack(int Num) {return FTracks[Num];}
  void __fastcall Play();
  void PrevTrack();
  void NextTrack();
  void __fastcall Stop();
};
//---------------------------------------------------------------------------
class TCDForm : public TForm
{
__published:
  TTimer *Timer1;
        TOpenDialog *OpenDiag;
        TMediaPlayer *BasePlayer;
        TPopupMenu *TypeMenu;
        TMenuItem *CD_M;
        TMenuItem *Comp_M;
  void __fastcall FormMouseDown(TObject *Sender, TMouseButton Button,
   TShiftState Shift, int X, int Y);
  void __fastcall FormCreate(TObject *Sender);
  void __fastcall FormMouseUp(TObject *Sender, TMouseButton Button,
   TShiftState Shift, int X, int Y);
  void __fastcall FormPaint(TObject *Sender);
        void __fastcall Timer1Timer(TObject *Sender);
        void __fastcall MenuClick(TObject *Sender);

private:
  char SkinName[20];
  TImage *Images[NumImgs];

public:
  AnsiString Comms[20];
  LabelInfo Labels[2];
  AnsiString szDirectory;
  TTrackClass *TrackMgr;

  __fastcall TCDForm(TComponent* Owner);
  __fastcall ~TCDForm();
  void Server(AnsiString Comm1);                 //Silent Console
  bool SplitComm(AnsiString StartStr);
};
//---------------------------------------------------------------------------
extern PACKAGE TCDForm *CDForm;
//---------------------------------------------------------------------------
#endif
