//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "CDView.h"
#include "PlayList.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"

TCDForm *CDForm;
HINSTANCE DLLInstance;
//FARPROC __stdcall pGetRegion;
typedef void (*MYPROC)(HRGN &Region);
MYPROC pGetRegion;

//FARPROC (pGetRegion)(HRGN R);
//---------------------------------------------------------------------------
void ConvertTime(char *Str, char *Str2, int iTime, TMPTimeFormats TF)
{
  int Min;

  if (TF == tfMilliseconds) {
    iTime /= 1000;                               //Convert to Seconds
    if (iTime < 60) sprintf(Str, "00.%02d", iTime);
    else {
      Min = div(iTime, 60).quot;                 //Get Minutes
      iTime -= 60 * Min;                         //Take Minutes off of seconds
      sprintf(Str, "%02d.%02d", Min, iTime);
    }
  }
  else if (TF == tfHMS) {
    Min = (iTime) >> 0 & (0xFFFF);
    sprintf(Str, "%02d.%02d", Min, (iTime) >> 8 & (0xF));
  }
  else if (TF == tfFrames) sprintf(Str, "%d", iTime);
  else if (TF == tfTMSF) {
    //Track  (iTime) >> 0 & (0xFF)
    //Minute (iTime) >> 8 & (0xFF)
    //Second (iTime) >> 16 & (0xFF)
    //Frame  (iTime) >> 24 & (0xFF) Unused
    sprintf(Str, "%02d.%02d", (iTime) >> 8 & (0xFF), (iTime) >> 16 & (0xFF));
    if (Str2)
     sprintf(Str2, "Track%d", (iTime) >> 0 & (0xFF));
  }
  else if (TF == tfMSF) {
    sprintf(Str, "%02d.%02d", (iTime) >> 0 & (0xFF), (iTime) >> 8 & (0xFF));
  }
  else sprintf(Str, "%d", (int)TF);
}
//---------------------------------------------------------------------------
__fastcall TCDForm::TCDForm(TComponent* Owner) : TForm(Owner)
{
  TrackMgr = new TTrackClass();
  TrackMgr->MediaPlayer = BasePlayer;
}
//---------------------------------------------------------------------------
__fastcall TCDForm::~TCDForm()
{
  Timer1->Enabled = false;
  for (int i = 0; i < NumImgs; i++) delete Images[i];
  BasePlayer->Stop();
  delete TrackMgr;
  //delete NameLabel.LFont;
  //delete PosLabel.LFont;
  if (DLLInstance) FreeLibrary(DLLInstance);
}
//---------------------------------------------------------------------------
void __fastcall TCDForm::FormCreate(TObject *Sender)
{
  Labels[0].LFont = new TFont();
  Labels[1].LFont = new TFont();
  Labels[0].LFont->Assign(Font);
  Labels[1].LFont->Assign(Font);
  BasePlayer->Open();
  BasePlayer->Frames = 5;
  TrackMgr->AddCDTrack();

  AnsiString Loc;
  Loc = szDirectory + "Skins\\BlueSky\\BlueSky.dll";
  DLLInstance = LoadLibrary(Loc.c_str());
  if (DLLInstance > 0) {
    pGetRegion = (MYPROC)GetProcAddress(DLLInstance, "_GetRegions");
    if (!pGetRegion) ShowMessage("No Func");
  }
  else ShowMessage("NoDLL");

  for (int i = 0; i < NumImgs; i++) Images[i] = new TImage(this);
  Server("GET_LOCATION");                        //Get Current Location
  Server("EXEC Default.scr");
  Canvas->StretchDraw(Images[0]->BoundsRect, Images[0]->Picture->Graphic);
}
//---------------------------------------------------------------------------
void __fastcall TCDForm::MenuClick(TObject *Sender)
{
  if (Sender == CD_M) {
    if (BasePlayer->DeviceType != dtCDAudio) {
      BasePlayer->Close();
      BasePlayer->FileName = "";
      BasePlayer->DeviceType = dtCDAudio;
      BasePlayer->Open();
    }
  }
  else if (Sender == Comp_M) {
    if (OpenDiag->Execute()) {
      BasePlayer->Stop();
      BasePlayer->DeviceType = dtAutoSelect;
      TrackMgr->CurrentTrack = 1;
      TrackMgr->ClearTracks();
      for (int i = 0; i < OpenDiag->Files->Count; i++) {
        TrackMgr->AddTrack(OpenDiag->Files->Strings[i]);
      }
      BasePlayer->FileName = TrackMgr->GetTrack(1).FileName;
      BasePlayer->Open();
    }
  }
}
//---------------------------------------------------------------------------
void __fastcall TCDForm::FormMouseDown(TObject *Sender, TMouseButton Button,
 TShiftState Shift, int X, int Y)
{
  RECT CurRect;

  Canvas->StretchDraw(Images[0]->BoundsRect, Images[0]->Picture->Graphic);

  for (int i = 2; i < NumImgs; i += 2) {
    CurRect = Images[i]->BoundsRect;
    if ((Y >= CurRect.top) & (Y <= CurRect.bottom)) {
      if ((X >= CurRect.left) & (X <= CurRect.right)) {
        Canvas->StretchDraw(Images[i]->BoundsRect, Images[i]->Picture->Graphic);
        break;
      }
    }
  }
}
//---------------------------------------------------------------------------
void __fastcall TCDForm::FormMouseUp(TObject *Sender, TMouseButton Button,
 TShiftState Shift, int X, int Y)
{
  RECT CurRect;

  Canvas->StretchDraw(Images[0]->BoundsRect, Images[0]->Picture->Graphic);

  for (int i = 1; i < NumImgs; i += 2) {
    CurRect = Images[i]->BoundsRect;
    if ((Y >= CurRect.top) & (Y <= CurRect.bottom)) {
      if ((X >= CurRect.left) & (X <= CurRect.right)) {
        Server("BUTTON_PRESS " + IntToStr(i));
        break;
      }
    }
  }
}
//---------------------------------------------------------------------------
void __fastcall TCDForm::FormPaint(TObject *Sender)
{
  HRGN Rgn;
  /*POINT P[8] = {{10, 0}, {35, 0}, {45, 1}, {54, 2}, {56, 103}, {2, 88}, {1, 35}, {13, 5}};
  Rgn = CreatePolygonRgn(P, 8, WINDING);*/
  pGetRegion(Rgn);
  SetWindowRgn(Handle, Rgn, true);
  Canvas->StretchDraw(Images[0]->BoundsRect, Images[0]->Picture->Graphic);
}
//---------------------------------------------------------------------------
void __fastcall TCDForm::Timer1Timer(TObject *Sender)
{
  char Msg1[30];
  char Msg2[100];
  int Pos;

  TrackInfo CurTrack;

  strcpy(Msg1, "");
  strcpy(Msg2, "");

  TrackMgr->GetDisplayLabels(Msg1, Msg2);

  if (Labels[0].Visible) {                       //Name Label
    Canvas->Brush->Color = Labels[0].BGColor;
    Canvas->Font = Labels[0].LFont;
    Canvas->TextOut(Labels[0].Pos.x, Labels[0].Pos.y, Msg2);
  }
  if (Labels[1].Visible) {                       //Pos
    Canvas->Brush->Color = Labels[1].BGColor;
    Canvas->Font = Labels[1].LFont;
    Canvas->TextOut(Labels[1].Pos.x, Labels[1].Pos.y, Msg1);
  }
}
//---------------------------------------------------------------------------
void TCDForm::Server(AnsiString Comm1)
{
  Comm1 = Comm1.Trim();                          //Remove any spaces L/R
  if (!SplitComm(Comm1)) return;                 //No command
  Comms[1] = Comms[1].UpperCase();               //Convert to upper case

  //---------------------------------------------\\
  if (Comms[1] == "ADD_IMAGE") {
    int Pic, Num;
    Pic = atoi(Comms[2].c_str());
    Num = Comms[3].Pos("$CDV2");
    if (Num > 0) {
      Comms[3].Delete(Num, 5);
      Comms[3].Insert(szDirectory, Num);
    }
    Images[Pic]->Picture->LoadFromFile(Comms[3]);
    Images[Pic]->Left   = atoi(Comms[4].c_str());
    Images[Pic]->Top    = atoi(Comms[5].c_str());
    Images[Pic]->Width  = atoi(Comms[6].c_str());
    Images[Pic]->Height = atoi(Comms[7].c_str());
    Images[Pic]->Transparent = (bool) atoi(Comms[8].c_str());
  }
  //---------------------------------------------\\
  else if (Comms[1] == "BUTTON_PRESS") {
    switch(Comms[2].ToInt()) {
      case 1: TrackMgr->PrevTrack(); break;
      case 3: BasePlayer->Pause(); break;
      case 5: TrackMgr->Play(); break;
      case 7: TrackMgr->Stop(); break;
      case 9: TrackMgr->NextTrack(); break;
      case 11:
        if (BasePlayer->DeviceType == dtCDAudio) BasePlayer->Eject();
      break;
      case 13: TypeMenu->Popup(Mouse->CursorPos.x, Mouse->CursorPos.y); break;
      case 17: Application->Minimize(); break;
      case 19: Close(); break;
      case 21:
        if (BasePlayer->DeviceType == dtCDAudio) TrackMgr->AddCDTrack();
        ListForm->ShowModal();
      break;
      default: ShowMessage("Unknown Button " + Comms[2]);
    }
  }
  //---------------------------------------------\\
  else if (Comms[1] == "ECHO") {
    AnsiString C_Message;
    C_Message = "";
    for (int i = 2; i < 20; i++) {
      if (Comms[i].Length() > 0) C_Message += Comms[i];
      C_Message += " ";
    }
    ShowMessage(C_Message);
  }
  //---------------------------------------------\\
  else if (Comms[1] == "EXEC") {
    //Runs a file of Server Commands
    char F_Line[100];                            //Characters to read
    ifstream File(Comms[2].c_str());             //Open file

    if (!File) ShowMessage("Couldn't exec: " + Comms[2]);
    else {
      while (!File.eof()) {                      //Loop until End of File
        File.getline(F_Line, sizeof(F_Line));    //Read Line
        Server(F_Line);
      }
    }
    File.close();                                //Close File
  }
  //---------------------------------------------\\
  else if (Comms[1] == "FORM_SIZE") {
    CDForm->Width = atoi(Comms[2].c_str());
    CDForm->Height = atoi(Comms[3].c_str());
    Width = atoi(Comms[2].c_str());
    Height = atoi(Comms[3].c_str());
  }
  //---------------------------------------------\\
  else if (Comms[1] == "GET_LOCATION") {
    //Retrives the location of the exe file
    char gDirectory[MAX_PATH];                   //Directory Size
    GetModuleFileName(NULL, gDirectory, MAX_PATH);
    szDirectory = ExtractFileDir(gDirectory);
    szDirectory = IncludeTrailingBackslash(szDirectory);
  }
  //---------------------------------------------\\
  else if (Comms[1] == "LABEL") {
    AnsiString S;
    int ArrNum, R, G, B;
    ArrNum = atoi(Comms[2].c_str());
    Labels[ArrNum].Visible = (bool) atoi(Comms[3].c_str());
    if (Labels[ArrNum].Visible) {
      Labels[ArrNum].Pos.x = atoi(Comms[4].c_str());
      Labels[ArrNum].Pos.y = atoi(Comms[5].c_str());
      Labels[ArrNum].LFont->Size = atoi(Comms[6].c_str());
      R = StrToInt("0x" + Comms[7].SubString(1, 2));  //Split to RBG
      G = StrToInt("0x" + Comms[7].SubString(3, 2));
      B = StrToInt("0x" + Comms[7].SubString(5, 2));
      Labels[ArrNum].LFont->Color = (TColor) RGB(R, G, B);
      R = StrToInt("0x" + Comms[8].SubString(1, 2));  //Split to RGB
      G = StrToInt("0x" + Comms[8].SubString(3, 2));
      B = StrToInt("0x" + Comms[8].SubString(5, 2));
      Labels[ArrNum].BGColor = (TColor) RGB(R, G, B); //Combine
      for (int i = 9; i < 20; i++) {                  //Get Font Name
        if (Comms[i].Length() > 0) {
          S += Comms[i];
          S += " ";
        }
      }
      Labels[ArrNum].LFont->Name = S;
    }
  }
  //---------------------------------------------\\
  else if (Comms[1] == "SKIN_NAME") {
    strcpy(SkinName, Comms[2].c_str());
  }
  //---------------------------------------------\\
  else ShowMessage("Unknown command: " + Comms[1]);
}
//---------------------------------------------------------------------------
bool TCDForm::SplitComm(AnsiString StartStr)
{
  int StringPos, Temp;
  int ArrayNum = 1;
  AnsiString TempComms[20];

  for (Temp = 1; Temp < 19; Temp++) {
    Comms[Temp] = "";                            //Clear Comms array
    TempComms[Temp] = "";
  }

  if (StartStr.Length() == 0) return false;      //If no String
  StartStr = StartStr.Trim();                    //Clear Spaces

  for (StringPos = 0; StringPos <= StartStr.Length(); StringPos++) {
    if (StartStr.IsDelimiter(" ", StringPos) == true) {
      ArrayNum++;
    }
    if (StartStr.IsDelimiter("#", StringPos) == true) return false;
    else TempComms[ArrayNum] += StartStr.c_str()[StringPos];
  }

  for (Temp = 1; Temp < 19; Temp++) {
    Comms[Temp] = TempComms[Temp].Trim();
  }
  return true;
}
//---------------------------------------------------------------------------
__fastcall TTrackClass::TTrackClass()
{
  ClearTracks();
}
//---------------------------------------------------------------------------
__fastcall TTrackClass::~TTrackClass()
{
  MediaPlayer = NULL;
}
//---------------------------------------------------------------------------
void TTrackClass::AddTrack(AnsiString File)
{
  if (!GetArrayPos()) return;

  FTracks[FNumTracks].FileName = File;
  FTracks[FNumTracks].Title = ExtractFileName(File);
  if (CDForm->BasePlayer->FileName == File) {
    ConvertTime(FTracks[FNumTracks].Length, NULL, CDForm->BasePlayer->Length,
     CDForm->BasePlayer->TimeFormat);
  }
  else strcpy(FTracks[FNumTracks].Length, "00:00");
}
//---------------------------------------------------------------------------
void TTrackClass::AddCDTrack()
{
  int CDTracks, TrackLength, LoopPos;
  //char Temp[50];
  ClearTracks();                                 //Clear Memory

  CDTracks = CDForm->BasePlayer->Tracks;         //Get Number of CD Tracks
  for (LoopPos = 1; LoopPos <= CDTracks; LoopPos++) {
    if (!GetArrayPos()) break;
    TrackLength = CDForm->BasePlayer->TrackLength[LoopPos];
    ConvertTime(FTracks[FNumTracks].Length, NULL, TrackLength, tfMSF);
    FTracks[FNumTracks].FileName = IntToStr(LoopPos);
    FTracks[FNumTracks].Title = "Track " + IntToStr(LoopPos);
//    ShowMessage(IntToStr(LoopPos) + ": " + IntToStr(TrackLength));
  }
}
//---------------------------------------------------------------------------
void TTrackClass::ChangeTrack(const int NewPosition, const bool AutoPlay)
{
  if (CDForm->BasePlayer->DeviceType == dtCDAudio) {
    if ((AutoPlay) | (MediaPlayer->Mode == mpPlaying)) {
      CDForm->BasePlayer->Pause();
      CDForm->BasePlayer->Position = NewPosition;
      CDForm->BasePlayer->Resume();
    }
    FCurrentTrack = NewPosition;
  }
  else {
    if ((AutoPlay) | (MediaPlayer->Mode == mpPlaying)) {
      CDForm->BasePlayer->Stop();
      CDForm->BasePlayer->FileName = FTracks[NewPosition].FileName;
      CDForm->BasePlayer->Open();
      CDForm->BasePlayer->Play();
    }
    FCurrentTrack = NewPosition;
  }
}
//---------------------------------------------------------------------------
void TTrackClass::ClearTracks()
{
  FNumTracks = 0;
  for (int i = 0; i < 100; i++) {
    FTracks[i].Title = " ";
    FTracks[i].FileName = "";
    strcpy(FTracks[i].Length, "00:00");
    FTracks[i].TimeLength = 0;
    //ZeroMemory((void*)FTracks, sizeof(FTracks));
  }
}
//---------------------------------------------------------------------------
bool TTrackClass::GetArrayPos()
{
  bool Found = false;
  for (int i = 1; i < 100; i++) {
    if (FTracks[i].Title.Length() == 0) {
      FNumTracks = i;
      Found = true;
      break;
    }
  }
  return Found;
}
//---------------------------------------------------------------------------
void __fastcall TTrackClass::GetDisplayLabels(char *M1, char *M2)
{
  TMPModes CurMode;

  CurMode = MediaPlayer->Mode;
  FPlayPosition = MediaPlayer->Position;

  if (CurMode == mpStopped) {
    //if (strlen(FTracks[FCurrentTrack].Length) > 0)
    if (FCurrentTrack > 0)
     ConvertTime(M1, NULL, MediaPlayer->Length, MediaPlayer->TimeFormat);
    else strcpy(M1, "00:00");

 //    sprintf(M2, "%03d %s", FCurrentTrack, FTracks[FCurrentTrack].Title.c_str());
  }
  else if (CurMode == mpOpen) strcpy(M1, "Open");
  else if ((CurMode == mpPlaying) | (CurMode == mpPaused)) {
    if (MediaPlayer->DeviceType == dtCDAudio) {
      char Temp[20];
      ConvertTime(M1, Temp, FPlayPosition, MediaPlayer->TimeFormat);
      sprintf(M2, "%03d %s", FCurrentTrack, Temp);
    }
    else {
      ConvertTime(M1, NULL, FPlayPosition, MediaPlayer->TimeFormat);
      sprintf(M2, "%03d %s", FCurrentTrack, FTracks[FCurrentTrack].Title.c_str());
    }
  }
}
//---------------------------------------------------------------------------
void __fastcall TTrackClass::Play()
{

  switch (MediaPlayer->Mode) {
    case mpPaused:         //UnPause
      MediaPlayer->Resume();
    break;
    case mpPlaying:
      ChangeTrack(FCurrentTrack, true);
    break;
    case mpStopped:
      if (MediaPlayer->DeviceType == dtCDAudio) AddCDTrack();
      FCurrentTrack = 1;
      MediaPlayer->StartPos = 1;
      MediaPlayer->Play();
    break;
  }
}
//---------------------------------------------------------------------------
void TTrackClass::PrevTrack()
{
  int NewTrack;

  if (FNumTracks == 1) return;                   //1 or 0 - return
  if (FCurrentTrack == 1) NewTrack = FNumTracks; //Go To End?
  else NewTrack = FCurrentTrack - 1;             //Go Back One

  ChangeTrack(NewTrack, false);                  //Change the Play Position
}
//---------------------------------------------------------------------------
void TTrackClass::NextTrack()
{
  int NewTrack;

  if (FNumTracks == 1) return;                   //1 or 0 - return
  if (FCurrentTrack == FNumTracks) NewTrack = 1; //Go To End?
  else NewTrack = FCurrentTrack + 1;             //Go Ahead One

  ChangeTrack(NewTrack, false);                  //Change the Play Position
}
//---------------------------------------------------------------------------
void __fastcall TTrackClass::SetPlayPosition(int Pos)
{
  if (CDForm->BasePlayer->DeviceType != dtCDAudio) {
    if (FTracks[FCurrentTrack].TimeLength == 0) {
      FTracks[FCurrentTrack].TimeLength = CDForm->BasePlayer->Length;
      ConvertTime(FTracks[FCurrentTrack].Length, NULL,
       FTracks[FCurrentTrack].TimeLength, CDForm->BasePlayer->TimeFormat);
    }
    if (Pos >= FTracks[FCurrentTrack].TimeLength) FCurrentTrack++;
  }

  FPlayPosition = Pos;
}
//---------------------------------------------------------------------------
void __fastcall TTrackClass::Stop()
{
  FCurrentTrack = 1;
  MediaPlayer->Stop();
}
//---------------------------------------------------------------------------



