//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "FVExtra.h"
#include "FView.h"
#include "Properties.h"
#include "About_Form.h"
#include "Search_Form.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
TFVManager *FVManager;
//---------------------------------------------------------------------------
__fastcall TFVManager::TFVManager()
{
  OFont = new TFont();
}
//---------------------------------------------------------------------------
__fastcall TFVManager::~TFVManager()
{
  delete OFont;
}
//---------------------------------------------------------------------------
void TFVManager::LoadOptions(AnsiString Loc)
{
  TIniFile *OptFile = new TIniFile(Loc);
  int Pos;
  bool OFStyle[4];

  //Environment----------------------------------\\
  OFont->Name    = OptFile->ReadString("ENV", "FName", "MS Sans Serif");
  OFont->Charset = OptFile->ReadInteger("ENV", "FChar", 1);
  OFont->Pitch   = (TFontPitch)OptFile->ReadInteger("ENV", "FPitch", 0);
  OFont->Size    = OptFile->ReadInteger("ENV", "FSize", 8);
  OFont->Color   = (TColor)OptFile->ReadInteger("ENV", "FCol", -214783640);
  OFStyle[0] = OptFile->ReadBool("ENV", "FStyle1", false);
  OFStyle[1] = OptFile->ReadBool("ENV", "FStyle2", false);
  OFStyle[2] = OptFile->ReadBool("ENV", "FStyle3", false);
  OFStyle[3] = OptFile->ReadBool("ENV", "FStyle4", false);
  FBackCl = (TColor)OptFile->ReadInteger("ENV", "BackCl", -2147483633);
  FFileCl = (TColor)OptFile->ReadInteger("ENV", "FileCl", -2147483643);
  FDirCl  = (TColor)OptFile->ReadInteger("ENV", "DirCl",  -2147483643);

  //View-----------------------------------------\\
  MainForm->FileList->Columns->Items[0]->Width = OptFile->ReadInteger("VIEW", "COL1", 145);
  MainForm->FileList->Columns->Items[1]->Width = OptFile->ReadInteger("VIEW", "COL2", 70);
  MainForm->FileList->Columns->Items[2]->Width = OptFile->ReadInteger("VIEW", "COL3", 130);
  MainForm->FileList->Columns->Items[3]->Width = OptFile->ReadInteger("VIEW", "COL4", 118);
  MainForm->FileList->Columns->Items[4]->Width = OptFile->ReadInteger("VIEW", "COL5", 62);
  MainWidth    = OptFile->ReadInteger("VIEW", "MainWidth", 800);
  MainHeight   = OptFile->ReadInteger("VIEW", "MainHeight", 600);
  PropWidth    = OptFile->ReadInteger("VIEW", "PropWidth", 350);
  PropHeight   = OptFile->ReadInteger("VIEW", "PropHeight", 460);
  SearchWidth  = OptFile->ReadInteger("VIEW", "SearchWidth", 800);
  SearchHeight = OptFile->ReadInteger("VIEW", "SearchHeight", 600);
  MainForm->LocationBar->Left = OptFile->ReadInteger("VIEW", "LBarX", 11);
  MainForm->LocationBar->Top  = OptFile->ReadInteger("VIEW", "LBarY", 30);
  MainForm->LocationBar->Visible = OptFile->ReadBool("VIEW", "LBarVis", true);
  MainForm->MenuBar->Left = OptFile->ReadInteger("VIEW", "MBarX", 11);
  MainForm->MenuBar->Top  = OptFile->ReadInteger("VIEW", "MBarY", 1);
  MainForm->MenuBar->Visible = OptFile->ReadBool("VIEW", "MBarVis", true);
  MainForm->StdBar->Left = OptFile->ReadInteger("VIEW", "SBarX", 334);
  MainForm->StdBar->Top  = OptFile->ReadInteger("VIEW", "SBarY", 1);
  MainForm->StdBar->Visible = OptFile->ReadBool("VIEW", "SBarVis", true);

  //Convert Font Settings------------------------\\
  if (OFStyle[0]) OFont->Style << fsBold;
  if (OFStyle[1]) OFont->Style << fsItalic;
  if (OFStyle[2]) OFont->Style << fsUnderline;
  if (OFStyle[3]) OFont->Style << fsStrikeOut;

  SetupUserInterface(1);
  delete OptFile;
}
//---------------------------------------------------------------------------
void TFVManager::LoadProgramLocations(AnsiString Loc)
{
  TIniFile *OptFile = new TIniFile(Loc);
  int Pos;
  AnsiString TempProgs[6];

  //Locations------------------------------------\\
  TempProgs[1] = OptFile->ReadString("FV41", "BIN", "($FV4)BinViewer.exe");
  TempProgs[2] = OptFile->ReadString("FV41", "CD",  "($FV4)CDViewer2.exe");
  TempProgs[3] = OptFile->ReadString("FV41", "REG", "($FV4)RegLearn.exe");
  TempProgs[4] = OptFile->ReadString("FV41", "IMG", "($FV4)ImgViewer.exe");
  TempProgs[5] = OptFile->ReadString("FV41", "TXT", "($FV4)TxtViewer.exe");

  //Change FV41 to real extension----------------\\
  for (int i = 1; i < 6; i++) {
    Pos = TempProgs[i].Pos("($FV4)");
    if (Pos > 0) {
      TempProgs[i].Delete(Pos, 6);                   //Delete ($FV4)
      TempProgs[i].Insert(MainForm->szDirectory, Pos);//Insert Directory
    }
    MainForm->Progs[i] = TempProgs[i];
  }

  delete OptFile;
}
//---------------------------------------------------------------------------
void TFVManager::SaveOptions(AnsiString Loc)
{
  TIniFile *OptFile = new TIniFile(Loc);

  OptFile->EraseSection("VIEW");
  //View-----------------------------------------\\

  OptFile->WriteInteger("VIEW", "COL1", MainForm->FileList->Columns->Items[0]->Width);
  OptFile->WriteInteger("VIEW", "COL2", MainForm->FileList->Columns->Items[1]->Width);
  OptFile->WriteInteger("VIEW", "COL3", MainForm->FileList->Columns->Items[2]->Width);
  OptFile->WriteInteger("VIEW", "COL4", MainForm->FileList->Columns->Items[3]->Width);
  OptFile->WriteInteger("VIEW", "COL5", MainForm->FileList->Columns->Items[4]->Width);
  OptFile->WriteInteger("VIEW", "MainWidth", MainForm->Width);
  OptFile->WriteInteger("VIEW", "MainHeight", MainForm->Height);
  OptFile->WriteInteger("VIEW", "MainWS", MainForm->WindowState);
  OptFile->WriteInteger("VIEW", "PropWidth", PropForm->Width);
  OptFile->WriteInteger("VIEW", "PropHeight", PropForm->Height);
  OptFile->WriteInteger("VIEW", "PropWS", PropForm->WindowState);
  OptFile->WriteInteger("VIEW", "SearchWidth", SearchForm->Width);
  OptFile->WriteInteger("VIEW", "SearchHeight", SearchForm->Height);
  OptFile->WriteInteger("VIEW", "SearchWS", SearchForm->WindowState);
  OptFile->WriteInteger("VIEW", "LBarX", MainForm->LocationBar->Left);
  OptFile->WriteInteger("VIEW", "LBarY", MainForm->LocationBar->Top);
  OptFile->WriteBool("VIEW", "LBarVis", MainForm->LocationBar->Visible);
  OptFile->WriteInteger("VIEW", "MBarX", MainForm->MenuBar->Left);
  OptFile->WriteInteger("VIEW", "MBarY", MainForm->MenuBar->Top);
  OptFile->WriteBool("VIEW", "MBarVis", MainForm->MenuBar->Visible);
  OptFile->WriteInteger("VIEW", "SBarX", MainForm->StdBar->Left);
  OptFile->WriteInteger("VIEW", "SBarY", MainForm->StdBar->Top);
  OptFile->WriteBool("VIEW", "SBarVis", MainForm->StdBar->Visible);

  OptFile->UpdateFile();
  delete OptFile;
}
//---------------------------------------------------------------------------
void TFVManager::SetupUserInterface(short FormNum)
{
  if (FormNum == 1) {                            //Main Form
    MainForm->Font->Assign(OFont);
    MainForm->DirList->Font->Assign(OFont);
    MainForm->FileList->Font->Assign(OFont);
    MainForm->DirList->Color = FDirCl;
    MainForm->FileList->Color = FFileCl;
    MainForm->Color = FBackCl;
  }
  else if (FormNum == 2) {                       //Properties Form
    PropForm->Font->Assign(OFont);
    PropForm->Color = FBackCl;
  }
  else if (FormNum == 3) {                       //Search Form
    SearchForm->Font->Assign(OFont);
    SearchForm->Color = FBackCl;
  }
}
//---------------------------------------------------------------------------
