//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "FView.h"
#include "Properties.h"
#include "About_Form.h"
#include "Search_Form.h"
#include "RegForm.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "FileList"
#pragma link "DirList"
#pragma link "Extension"
#pragma resource "*.dfm"
TMainForm *MainForm;     
//Initialise-----------------------------------------------------------------
__fastcall TMainForm::TMainForm(TComponent* Owner)
        : TForm(Owner)
{
  AnsiString Params;         
  char gDirectory[MAX_PATH];                     //Directory Size

  if (!FVManager) FVManager = new TFVManager();
  GetModuleFileName(NULL, gDirectory, MAX_PATH); //Get Location
  szDirectory = ExtractFileDir(gDirectory);
  szDirectory = IncludeTrailingBackslash(szDirectory);

  FVManager->LoadProgramLocations(szDirectory + "Settings.ini");

  if (!FileExists("RegInfo.ini")) {              //Run RegLearn?
    if (!LearnForm) LearnForm = new TLearnForm(this);
    LearnForm->ShowModal();
    //ResetProgram();
  }
  
  FileExt->Init();
  DirList->Init();                               //Initialize Components
  FileList->Init();
  FVManager->LoadOptions(szDirectory + "Settings.ini");

  Params = Application->Title;                   //Get Parameters
  Application->Title = "Adv File Viewer";

  if (Params.Length() > 0)
   DirList->Directory = Params;                  //User Specific Dir

  else DirList->Directory = szDirectory;         //Default Dir
  Application->OnHint = OnDisplayHint;

  Width = FVManager->MainWidth;                  //Set Custom Size
  Height = FVManager->MainHeight;
}
//Form Events----------------------------------------------------------------
void __fastcall TMainForm::FormClose(TObject *Sender, TCloseAction &Action)
{
  FVManager->SaveOptions(szDirectory + "Settings.ini");
  //Action = caFree;
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::FormKeyDown(TObject *Sender, WORD &Key,
      TShiftState Shift)
{
  if (Shift.Contains(ssAlt)) {
    if (Key == 13) MenuClick(Prop_M);                //Enter
    else if ((Key == 88) | (Key == 120)) Close();    //X
  }
  else if (Shift.Contains(ssCtrl)) {
    if ((Key == 66) | (Key == 98)) RunFile(2);  //B
    else if ((Key == 67) | (Key == 99)) FileList->CopyFiles(false); //C
    else if ((Key == 69) | (Key == 101)) RunFile(6); //E
    else if ((Key == 73) | (Key == 105)) RunFile(4); //I
    else if ((Key == 79) | (Key == 111)) RunFile(1); //O
    else if ((Key == 82) | (Key == 114)) {           //R
      if (FileList->Selected) FileList->Selected->EditCaption();
      else if (DirList->Selected) DirList->Selected->EditText();
    }
    else if ((Key == 84) | (Key == 116)) RunFile(3); //T
    else if ((Key == 86) | (Key == 118)) FileList->PasteFiles();    //V
    else if ((Key == 88) | (Key == 120)) FileList->CopyFiles(true); //X
  }
  else {
    if (Key == VK_F5) {
      DirList->Refresh();
      FileList->Refresh_List();
    }
    else if (Key == VK_RETURN) RunFile();
    else if (Key == VK_DELETE) {
      if ((!FileList->IsEditing()) & (!DirList->IsEditing()))
       FileList->DeleteFiles(Shift.Contains(ssShift));
    }
    //ShowMessage(Key);
  }
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::OnDisplayHint(TObject *Sender)
{
  HintLabel->Caption = Application->Hint;
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::DirMenuClick(TObject *Sender)
{
  if (Sender == Prop_DM) {
    if (MainForm->DirList->Selected->Level == 0) return;
    else if (MainForm->DirList->Selected->Level == 1) PropForm->Mode = pvDrive;
    else if (MainForm->DirList->Selected->Level  > 1) PropForm->Mode = pvDir;
    PropForm->Show();
  }
  else if (Sender == Play_DM) SpawnFile(Progs[2], "", false);
  else if (Sender == Eject_DM) {
    mciSendString("set cdaudio door open", NULL, 0, NULL);
  }
  else if (Sender == Inject_DM) {
    mciSendString("set cdaudio door closed", NULL, 0, NULL);
  }
  else if (Sender == NewDir_DM) SetupCreateDir(DirList->Selected);
  else if (Sender == RenameDir_DM) {
    if (DirList->Selected) DirList->Selected->EditText();
  }
  else if (Sender == DelDir_DM) FileList->DeleteFiles(false);
}
//Menu Events---------------------------------------------------------------------------
void __fastcall TMainForm::DirMenuPopup(TObject *Sender)
{
  Play_DM->Visible   = false;                    //Invisible by default
  Eject_DM->Visible  = false;
  Inject_DM->Visible = false;

  if (DirList->Selected->Level == 1) {           //Drives
    if (DirList->Selected->ImageIndex == 5) {    //CD Drive
      Play_DM->Visible = true;
      Eject_DM->Visible = true;
      Inject_DM->Visible = true;
    }
  }
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::FileMenuClick(TObject *Sender)
{
  if (Sender == Open_FM) RunFile();
  else if (Sender == BinView_FM) RunFile(2);
  else if (Sender == ImgView_FM) RunFile(4);
  else if (Sender == TxtView_FM) RunFile(3);
  else if (Sender == Prop_FM) {
    PropForm->Mode = pvFile;
    PropForm->Show();
  }
  else if (Sender == Cut_FM) FileList->CopyFiles(true);
  else if (Sender == Copy_FM) FileList->CopyFiles(false);
  else if (Sender == Paste_FM) FileList->PasteFiles();
  else if (Sender == Delete_FM) FileList->DeleteFiles(false);
  else if (Sender == Rename_FM) {
    if (FileList->Selected) FileList->Selected->EditCaption();
  }
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::MenuClick(TObject *Sender)
{
  if (Sender == Run_M) RunFile();
  else if (Sender == View_M) RunFile(3);
  else if (Sender == Prop_M) {
    PropForm->Mode = pvFile;
    PropForm->Show();
  }
  else if (Sender == RenameFile_M) {
    if (FileList->Selected) FileList->Selected->EditCaption();
  }
  else if (Sender == RenameDir_M) {
    if (DirList->Selected) DirList->Selected->EditText();
  }
  else if (Sender == CreateDir_M) SetupCreateDir(DirList->Selected);
  else if (Sender == Del_M) FileList->DeleteFiles(false);
  else if (Sender == Exit_M) Close();
  else if (Sender == Cut_M) FileList->CopyFiles(true);
  else if (Sender == Copy_M) FileList->CopyFiles(false);
  else if (Sender == Paste_M) FileList->PasteFiles();
  else if (Sender == Search_M) SearchForm->Show();
  else if (Sender == ProgOptions_M) {
    SpawnFile(szDirectory + "FV4Options.exe" , "", true);
    ResetProgram();
  }
  else if (Sender == Learn_M) {
    LearnForm->ShowModal();
    ResetProgram();
  }
  else if (Sender == About_M) AboutBox->Show();
  else if (Sender == VLarge_M) ChangeFileListView(1);
  else if (Sender == VSmall_M) ChangeFileListView(2);
  else if (Sender == VList_M) ChangeFileListView(3);
  else if (Sender == VDetails_M) ChangeFileListView(4);
  else if (Sender == VThumb_M) ChangeFileListView(5);
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::StdBarClick(TObject *Sender)
{
  if (Sender == Up_TB) DirList->UpDirectory();
  else if (Sender == Cut_TB) FileList->CopyFiles(true);
  else if (Sender == Copy_TB) FileList->CopyFiles(false);
  else if (Sender == Paste_TB) FileList->PasteFiles();
  else if (Sender == Delete_TB) FileList->DeleteFiles(false);
  else if (Sender == Run_TB) RunFile();
  else if (Sender == Open_TB) RunFile(3);
  else if (Sender == Refresh_TB) {
    DirList->Refresh();
    FileList->Refresh_List();
  }
}
//Other----------------------------------------------------------------------
void TMainForm::ChangeFileListView(const int ViewNum)
{
  //ViewNum 1: Large, 2: Small, 3: List, 4: Detail, 5: Thumb
  FileList->Tag = 0;
  if (ViewNum == 1) {
    VLarge_M->Checked = true;
    FileList->ViewStyle = vsIcon;
  }
  else if (ViewNum == 2) {
    VSmall_M->Checked = true;
    FileList->ViewStyle = vsSmallIcon;

  }
  else if (ViewNum == 3) {
    VList_M->Checked = true;
    FileList->ViewStyle = vsList;
  }
  else if (ViewNum == 4) {
    VDetails_M->Checked = true;
    FileList->ViewStyle = vsReport;
  }
  else if (ViewNum == 5) {
    VThumb_M->Checked = true;
    FileList->Tag = 1;
    FileList->ViewStyle = vsIcon;
  }
  FileList->Invalidate();
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::Rename_Directory(TObject *Sender,
      TTreeNode *Node, AnsiString &S)
{
  AnsiString OldDir;
  AnsiString NewDir;
  AnsiString Tmp;
  int Status;

  Tmp = DirList->Directory;                      //Take Dir
  Tmp = ExcludeTrailingBackslash(Tmp);           //Remove Backslash
  Tmp += ".tmp";                                 //Change it to a file
  //Remove the file, thus going up one level-----\\
  Tmp = ExtractFileDir(Tmp);

  OldDir = IncludeTrailingBackslash(Tmp) + Node->Text;
  NewDir = IncludeTrailingBackslash(Tmp) + S;

  Status = rename(OldDir.c_str(), NewDir.c_str());
  if (Status == -1) {                            //Error?
    S = Node->Text;                              //Revert Back
    if (errno == EEXIST) ShowMessage("Directory already exists");
    else if (errno == ENOENT) ShowMessage("Can't find Directory: " + OldDir);
    else if (errno == ENOTSAM) ShowMessage("Not same device");
  }
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::Rename_File(TObject *Sender, TListItem *Item,
      AnsiString &S)
{
  if (!RenameFile(Item->Caption, S)) {
    ShowMessage("Unable to rename file: " + Item->Caption);
    S = Item->Caption;                           //Revert back
  }
}
//---------------------------------------------------------------------------
void TMainForm::ResetProgram()
{
  if (Application->MessageBox("Adv FileViewer Must be Reset now, Continue?",
   "Reset?", MB_YESNO | MB_ICONQUESTION) == IDYES) {
    SpawnFile(szDirectory + "FileViewer4.exe", DirList->Directory , false);
    Close();
  }
}
//---------------------------------------------------------------------------
void TMainForm::RunFile(short OverideRunType)
{
  short RunType;
  int prval;
  AnsiString FName;
  AnsiString DirName = IncludeTrailingBackslash(DirList->Directory);
  int X, Y, Z;

  if (FileList->SelCount == 0) return;

  for (int i = 0; i < FileList->SelectedFiles->Count; i++) {
    FName = FileList->SelectedFiles->Strings[i]; //Get Current File
    //Get Run Type-------------------------------\\
    if (OverideRunType > -1) RunType = OverideRunType;
    else {                                       //Find Settings
      if (FileExt->CheckExists(ExtractFileExt(FName), X, Y, Z)) {
        RunType = FileExt->GetExtSearch(X, Y, Z).LoadType;
      }
      else RunType = 1;                          //Use Default
    }
    //Run the file-------------------------------\\
    if (RunType == 1) {                          //Use Windows
      prval = (int)ShellExecute(MainForm->Handle, "open", FName.c_str(), NULL,
       DirList->Directory.c_str(), SW_SHOW);
      if (prval <= 32) {                         //Error opening File
        ViewFile(DirName + FName);               //View Instead
      }
    }
    else {
      FName = DirName + FName;                   //Add Directory
      if (RunType == 2)
       SpawnFile(Progs[1], FName, false);        //Run Binary
      else if (RunType == 4)
       SpawnFile(Progs[4], FName, false);        //Run Image
      else if (RunType == 6) SpawnFile(FName, "", false);
      else if (RunType == 7) SpawnFile(Progs[2], "", false);
      else SpawnFile(Progs[5], FName, false);    //Run Text
    }
  }
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::SetupCreateDir(TTreeNode *ParNode)
{
  AnsiString CurDir, NewDir;
  int TestPos = 1;

  if (!ParNode) return;                          //No Selected Item

  CurDir = IncludeTrailingBackslash(DirList->Directory);
  NewDir = "NewDir";

  if (DirectoryExists(CurDir + NewDir)) {        //See if dir exists
    while(1) {                                   //It does so use a num
      if (!DirectoryExists(CurDir + NewDir + IntToStr(TestPos))) {
        NewDir += IntToStr(TestPos);
        break;
      }
      else TestPos++;
    }
  }

  if (!CreateDir(CurDir + NewDir)) {             //C if temp dir can be created
    ShowMessage("Unable to Create Directory");
    return;
  }

  ParNode->Expand(false);
}
//---------------------------------------------------------------------------
void TMainForm::SpawnFile(AnsiString File, AnsiString args, bool Wait)
{
  AnsiString Prog;
  STARTUPINFO si;
  PROCESS_INFORMATION pi;

  if (!FileExists(File)) {                       //Check if file exists
    ShowMessage("File not found: " + File);      //Nope
    return;
  }

  ZeroMemory(&si, sizeof(si));
  ZeroMemory(&pi, sizeof(pi));

  si.cb = sizeof(si);
  si.lpReserved = NULL;
  si.lpReserved2 = NULL;
  si.cbReserved2 = 0;
  si.lpDesktop = NULL;
  si.dwFlags = 0;

  Prog = File + " " + args;                      //Must be name and params
   if (CreateProcess(NULL, Prog.c_str(), NULL, NULL, false,
   NORMAL_PRIORITY_CLASS, NULL, ExtractFileDir(File).c_str(), &si, &pi) == 0) {
    ShowMessage("Unable to run program: " + File);
    return;
  }

  if (Wait) WaitForSingleObject(pi.hProcess, INFINITE);
}
//---------------------------------------------------------------------------
void TMainForm::ViewFile(AnsiString FileName)
{
  SpawnFile(Progs[5], FileName, false);          //Run Text
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::FileListDblClick(TObject *Sender)
{
  RunFile();
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::FileListCustomDrawItem(TCustomListView *Sender,
      TListItem *Item, TCustomDrawState State, bool &DefaultDraw)
{
  if (FileList->ViewStyle != vsIcon) return;
  if (FileList->Tag == 0) return;                //No Thumb
  if (Item->Selected) return;                    //Don't Draw selected Images

  AnsiString NewName;
  RECT TxtRect = Item->DisplayRect(drLabel);
  RECT ImgRect = Item->DisplayRect(drIcon);

  NewName = ExtractFileExt(Item->Caption);       //Hold Extension
  NewName = NewName.UpperCase();                 //Convert to uppercase
  if (NewName == ".BMP") {                       //Bitmap
    Graphics::TBitmap *BImage = new Graphics::TBitmap();
    BImage->LoadFromFile(Item->Caption);
    Sender->Canvas->StretchDraw(ImgRect, BImage);
  }
  else if (NewName == ".ICO") {                  //Icon
    TIcon *IImage = new TIcon();
    IImage->LoadFromFile(Item->Caption);
    Sender->Canvas->StretchDraw(ImgRect, IImage);
  }
  else if ((NewName == ".JPG") | (NewName == ".JPE") | (NewName == ".JPEG")) {
    TJPEGImage *JImage = new TJPEGImage();
    JImage->LoadFromFile(Item->Caption);
    Sender->Canvas->StretchDraw(ImgRect, JImage);
  }
  else return;                                   //Other, Don't Draw

  if (Item->Selected) {
    Sender->Canvas->Brush->Color = clHighlight;
    Sender->Canvas->Font->Color = clHighlightText;
  }
  else {
    Sender->Canvas->Brush->Color = FileList->Color;
    Sender->Canvas->Font->Color = clBtnText;
  }

  NewName = MinimizeName(Item->Caption, Sender->Canvas, 10);
  Sender->Canvas->TextRect(TxtRect, TxtRect.left, TxtRect.top, NewName);

  DefaultDraw = false;
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::FormResize(TObject *Sender)
{
  int W, H;
  FVManager->SetupUserInterface(1);

  W = Width - 8;
  H = Height - 28;

  HintLabel->Caption = "";

  ControlBar->Left = 0;
  ControlBar->Width = W;

  StatusPanel->Height = File_L->Height + 4;
  StatusPanel->Left = 0;
  StatusPanel->Top = H - StatusPanel->Height;
  StatusPanel->Width = W;

  DirList->Left = 6;
  DirList->Top = ControlBar->Height + 6;
  DirList->Width = W / 3.668f;
  DirList->Height = StatusPanel->Top - DirList->Top - 6;

  FileList->Left = DirList->Width + 12;
  FileList->Top = ControlBar->Height + 5;
  FileList->Width = (W - FileList->Left) - 6;
  FileList->Height = StatusPanel->Top - FileList->Top - 6;
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::ControlMenuClick(TObject *Sender)
{
  if (Sender == Loc_CM) {
    Loc_CM->Checked = !Loc_CM->Checked;
    LocationBar->Visible = Loc_CM->Checked;
  }
  if (Sender == Menu_CM) {
    Menu_CM->Checked = !Menu_CM->Checked;
    MenuBar->Visible = Menu_CM->Checked;
  }
  else if (Sender == Std_CM) {
    Std_CM->Checked = !Std_CM->Checked;
    StdBar->Visible = Std_CM->Checked;
  }
}
//---------------------------------------------------------------------------

