//---------------------------------------------------------------------------
#ifndef FViewH
#define FViewH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ComCtrls.hpp>
#include <Menus.hpp>
#include <Process.h>
#include <ExtCtrls.hpp>
#include <MMSystem.h>
#include <Graphics.hpp>
#include <dos.h>
#include <ToolWin.hpp>
#include <ImgList.hpp>
#include "DirList.h"
#include "FileList.h"
#include "Extension.h"
#include "FVExtra.h"
//---------------------------------------------------------------------------
enum TViewTypes {pvFile, pvDrive, pvDir} ;
//---------------------------------------------------------------------------
class TMainForm : public TForm
{
__published:
  TFileList *FileList;
  TDirList *DirList;
  TExtension *FileExt;

  TMainMenu *MainMenu;                           //Main Menu
  TMenuItem *File_M;                             //File
  TMenuItem *View_M;
  TMenuItem *Run_M;
  TMenuItem *Prop_M;
  TMenuItem *MN1;
  TMenuItem *CreateDir_M;
  TMenuItem *RenameDir_M;
  TMenuItem *RenameFile_M;
  TMenuItem *Del_M;
  TMenuItem *MN2;
  TMenuItem *Exit_M;
  TMenuItem *Edit_M;                             //Edit
  TMenuItem *Cut_M;
  TMenuItem *Copy_M;
  TMenuItem *Paste_M;
  TMenuItem *MN3;
  TMenuItem *Search_M;
  TMenuItem *View_MM;                            //View
  TMenuItem *VLarge_M;
  TMenuItem *VSmall_M;
  TMenuItem *VList_M;
  TMenuItem *VDetails_M;
  TMenuItem *VThumb_M;
  TMenuItem *Options_M;                          //Options
  TMenuItem *ProgOptions_M;
  TMenuItem *Learn_M;
  TMenuItem *Help_M;                             //Help
  TMenuItem *About_M;
  TPopupMenu *FileList_PM;                       //File List Menu
  TMenuItem *Open_FM;
  TMenuItem *View_FM;
  TMenuItem *Prop_FM;
  TMenuItem *FN1;
  TMenuItem *Cut_FM;
  TMenuItem *Copy_FM;
  TMenuItem *Paste_FM;
  TMenuItem *FN2;
  TMenuItem *Delete_FM;
  TMenuItem *Rename_FM;
  TMenuItem *BinView_FM;
  TMenuItem *ImgView_FM;
  TMenuItem *TxtView_FM;
  TPopupMenu *DirList_PM;                        //Directory List Menu
  TMenuItem *Prop_DM;
  TMenuItem *Eject_DM;
  TMenuItem *Inject_DM;
  TMenuItem *NewDir_DM;
  TMenuItem *DN1;
  TMenuItem *RenameDir_DM;
  TMenuItem *DelDir_DM;
  TMenuItem *Play_DM;
  TPopupMenu *ControlBarMenu;                    //Control Bar Menu
  TMenuItem *Menu_CM;
  TMenuItem *Std_CM;
  TMenuItem *Loc_CM;
  TControlBar *ControlBar;                       //Control Bar
  TToolBar *MenuBar;                             //Menu ToolBar
  TToolButton *File_TB;
  TToolButton *Edit_TB;
  TToolButton *Options_TB;
  TToolButton *Help_TB;
  TToolButton *View_TB;
  TToolBar *StdBar;                              //Standard ToolBar
  TImageList *StdImages;
  TToolButton *Up_TB;
  TToolButton *Refresh_TB;
  TToolButton *Sep1;
  TToolButton *Cut_TB;
  TToolButton *Copy_TB;
  TToolButton *Paste_TB;
  TToolButton *Sep2;
  TToolButton *Delete_TB;
  TToolButton *Run_TB;
  TToolButton *Open_TB;
  TPanel *LocationBar;                           //Location Toolbar
  TEdit *CurrentDir_E;
  TLabel *Location_L;
  TPanel *StatusPanel;                           //Status Panel
  TLabel *HintLabel;
  TLabel *File_L;

  void __fastcall MenuClick(TObject *Sender);
  void __fastcall FormKeyDown(TObject *Sender, WORD &Key,
   TShiftState Shift);
  void __fastcall Rename_File(TObject *Sender, TListItem *Item,
   AnsiString &S);
  void __fastcall ControlMenuClick(TObject *Sender);
  void __fastcall FileMenuClick(TObject *Sender);
  void __fastcall DirMenuClick(TObject *Sender);
  void __fastcall DirMenuPopup(TObject *Sender);
  void __fastcall Rename_Directory(TObject *Sender, TTreeNode *Node,
   AnsiString &S);
  void __fastcall FileListDblClick(TObject *Sender);
  void __fastcall FormClose(TObject *Sender, TCloseAction &Action);
  void __fastcall FileListCustomDrawItem(TCustomListView *Sender,
   TListItem *Item, TCustomDrawState State, bool &DefaultDraw);
  void __fastcall StdBarClick(TObject *Sender);
  void __fastcall FormResize(TObject *Sender);

protected:
  void __fastcall OnDisplayHint(TObject *Sender);

private:
  void ResetProgram();
  void RunFile(short OverideRunType = -1);
  void __fastcall SetupCreateDir(TTreeNode *ParNode);

public:
  AnsiString Progs[6];
  AnsiString szDirectory;

  __fastcall TMainForm(TComponent* Owner);
  void ChangeFileListView(const int ViewNum);
  void SpawnFile(AnsiString File, AnsiString args, bool Wait);
  void ViewFile(AnsiString FileName);
};
//---------------------------------------------------------------------------
extern PACKAGE TMainForm *MainForm;
//---------------------------------------------------------------------------
#endif
