//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "Options.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TOptForm *OptForm;
//---------------------------------------------------------------------------
bool ExtTo3Ints(AnsiString Ex, int &I1, int &I2, int &I3)
{
  int X, Y, Z;
  Ex = AnsiUpperCase(Ex);                        //Convert to upper case

  if (Ex.Length() == 0) return false;
  else if (Ex.Length() == 2) Ex += "  ";         //Extend length
  else if (Ex.Length() == 3) Ex += " ";
  else if (Ex.Length() > 4) return false;        //Too long

  X = int(Ex.c_str()[1] - 48);                   //Convert Ascii to Array
  Y = int(Ex.c_str()[2] - 32);
  Z = int(Ex.c_str()[3] - 32);

  if (X > 48) return false;                      //Incase of mistake
  else if (Y > 60) return false;
  else if (Z > 60) return false;
  if (X < 0) return false;

  I1 = X;                                        //Parse result as params
  I2 = Y;
  I3 = Z;

  return true;
}
//---------------------------------------------------------------------------
__fastcall TOptForm::TOptForm(TComponent* Owner)
        : TForm(Owner)
{
  BackCl = BackCl_S->Brush->Color;
  FileCl = FileCl_S->Brush->Color;
  DirCl  = DirCl_S->Brush->Color;
}
//---------------------------------------------------------------------------
void __fastcall TOptForm::FormCreate(TObject *Sender)
{
  char gDirectory[MAX_PATH];                     //Directory Size
  GetModuleFileName(NULL, gDirectory, MAX_PATH); //Get Location
  szDirectory = ExtractFileDir(gDirectory);
  szDirectory = IncludeTrailingBackslash(szDirectory);
  //szDirectory = "E:\\AdvFileViewer\\";

  //ExtListView->SmallImages = Ext->SmallIcons;
  //ExtListView->LargeImages = Ext->SmallIcons;

  LoadExtensions(szDirectory + "RegInfo.ini");
  LoadOptions(szDirectory + "Settings.ini");
}
//---------------------------------------------------------------------------
void __fastcall TOptForm::MainButtonClick(TObject *Sender)
{
  if (Sender == Save_B) {
    SaveExtensions(szDirectory + "RegInfo.ini");
    SaveOptions(szDirectory + "Settings.ini");
  }
  else if (Sender == Exit_B) Close();
  else if (Sender == FTAdd_B) {
    NewExtension();
  }
  else if (Sender == FTRemove_B) {
    if (ExtListView->Selected)
     ExtListView->Selected->Delete();
  }
  else if (Sender == ChFont_B) {
    FontDiag->Font = OptForm->Font;
    if (FontDiag->Execute()) {
      OptForm->Font = FontDiag->Font;
    }
  }
}
//---------------------------------------------------------------------------
void __fastcall TOptForm::ExtListViewSelectItem(TObject *Sender,
      TListItem *Item, bool Selected)
{
  if (!Item) return;                             //No Item Selected

  FTExt_E->Text = Item->Caption;
  FTDesc_E->Text = Item->SubItems->Strings[0];
  FTOpen_CB->ItemIndex = atoi(Item->SubItems->Strings[3].c_str()) - 1;
  FTIcFile_E->Text = Item->SubItems->Strings[1];
  FTIcNum_E->Text = Item->SubItems->Strings[2];
}
//---------------------------------------------------------------------------
void __fastcall TOptForm::FTExtChange(TObject *Sender)
{
  TListItem *SelItem;
  SelItem = ExtListView->Selected;

  if (!SelItem) return;

  if (Sender == FTExt_E)
   SelItem->Caption = FTExt_E->Text;
  else if (Sender == FTDesc_E)
   SelItem->SubItems->Strings[0] = FTDesc_E->Text;
  else if (Sender == FTOpen_CB)
   SelItem->SubItems->Strings[3] = IntToStr(FTOpen_CB->ItemIndex + 1);
  else if (Sender == FTIcFile_E)
   SelItem->SubItems->Strings[1] = FTIcFile_E->Text;
  else if (Sender == FTIcNum_E)
   SelItem->SubItems->Strings[2] = FTIcNum_E->Text;
}
//---------------------------------------------------------------------------
void TOptForm::DisplayCustomSettings()
{
  BackCl_S->Brush->Color = BackCl;
  FileCl_S->Brush->Color = FileCl;
  DirCl_S->Brush->Color = DirCl;
}
//---------------------------------------------------------------------------
void TOptForm::LoadExtensions(AnsiString RegFileName)
{
  int X, Y, Z;
  char Line[200];
  AnsiString S;

  TListItem *Item;

  ifstream RegFile(RegFileName.c_str());
  if (!RegFile) {
    ShowMessage("Can't open extension file");
    return;
  }

  RegFile.getline(Line, 5);                      //FourCC

  while(!RegFile.eof()) {
    RegFile.getline(Line, 200);                  //Read Line
    SplitComm(Line);                             //Split the Line

    Item = ExtListView->Items->Add();
    Item->Caption = FComms[1];
    Item->SubItems->Add(FComms[2]);
    Item->SubItems->Add(FComms[3]);
    Item->SubItems->Add(FComms[4]);
    Item->SubItems->Add(FComms[5]);
  }

  RegFile.close();
}
//---------------------------------------------------------------------------
void TOptForm::LoadOptions(AnsiString Loc)
{
  TIniFile *OptFile = new TIniFile(Loc);

  //Locations------------------------------------\\
  Loc1_E->Text = OptFile->ReadString("FV41", "BIN", "($FV4)BinViewer.exe");
  Loc2_E->Text = OptFile->ReadString("FV41", "CD",  "($FV4)CDViewer2.exe");
  Loc3_E->Text = OptFile->ReadString("FV41", "REG", "($FV4)RegLearn.exe");
  Loc4_E->Text = OptFile->ReadString("FV41", "IMG", "($FV4)ImgViewer.exe");
  Loc5_E->Text = OptFile->ReadString("FV41", "TXT", "($FV4)TxtViewer.exe");

  //Environment----------------------------------\\
  BackCl = (TColor)OptFile->ReadInteger("ENV", "BackCl", -2147483633);
  FileCl = (TColor)OptFile->ReadInteger("ENV", "FileCl", -2147483643);
  DirCl  = (TColor)OptFile->ReadInteger("ENV", "DirCl",  -2147483643);

  DisplayCustomSettings();
  delete OptFile;
}
//---------------------------------------------------------------------------
void TOptForm::NewExtension()
{
  TListItem *NewItem;
  NewItem = ExtListView->Items->Add();

  NewItem->Caption = ".111";
  NewItem->SubItems->Add("New Extension");
  NewItem->SubItems->Add("C:\\Windows\\System\\Shell32.dll");
  NewItem->SubItems->Add("0");
  NewItem->SubItems->Add("1");

  NewItem->Selected = true;                      //Move to new Item
}
//---------------------------------------------------------------------------
void TOptForm::SaveExtensions(AnsiString FileName)
{
  int Pos;
  char Line[200];

  TListItem *Item;
  ExtListView->AlphaSort();                      //Sort the list

  ofstream RegFile(FileName.c_str());
  if (!RegFile) {
    ShowMessage("Can't open extension file");
    return;
  }

  RegFile << "FV41\n";                           //Add Four CCs

  for (Pos = 0; Pos < ExtListView->Items->Count; Pos++) {
    Item = ExtListView->Items->Item[Pos];
    if (Item->Caption.Length() > 0) {
      RegFile << Item->Caption.UpperCase().c_str() << "; ";
      RegFile << Item->SubItems->Strings[0].c_str() << "; ";
      RegFile << Item->SubItems->Strings[1].c_str() << "; ";
      RegFile << Item->SubItems->Strings[2].c_str() << "; ";
      RegFile << Item->SubItems->Strings[3].c_str() << ";" << endl;
    }
  }

  RegFile.close();
}
//---------------------------------------------------------------------------
void TOptForm::SaveOptions(AnsiString Loc)
{
  //int i;
  TIniFile *OptFile = new TIniFile(Loc);

  OptFile->EraseSection("FV41");
  OptFile->EraseSection("ENV");

  //Locations------------------------------------\\
  OptFile->WriteString("FV41", "BIN", Loc1_E->Text);
  OptFile->WriteString("FV41", "CD",  Loc2_E->Text);
  OptFile->WriteString("FV41", "REG", Loc3_E->Text);
  OptFile->WriteString("FV41", "IMG", Loc4_E->Text);
  OptFile->WriteString("FV41", "TXT", Loc5_E->Text);

  //Environment----------------------------------\\
  OptFile->WriteString("ENV",  "FName",  Font->Name);
  OptFile->WriteInteger("ENV", "FChar",  (int)Font->Charset);
  OptFile->WriteInteger("ENV", "FPitch", (int)Font->Pitch);
  OptFile->WriteInteger("ENV", "FSize",  (int)Font->Size);
  OptFile->WriteInteger("ENV", "FCol",   (int)Font->Color);
  OptFile->WriteBool("ENV", "FStyle1", Font->Style.Contains(fsBold));
  OptFile->WriteBool("ENV", "FStyle2", Font->Style.Contains(fsItalic));
  OptFile->WriteBool("ENV", "FStyle3", Font->Style.Contains(fsUnderline));
  OptFile->WriteBool("ENV", "FStyle4", Font->Style.Contains(fsStrikeOut));
  OptFile->WriteInteger("ENV", "BackCl", BackCl);
  OptFile->WriteInteger("ENV", "FileCl", FileCl);
  OptFile->WriteInteger("ENV", "DirCl",  DirCl);

  OptFile->UpdateFile();
  delete OptFile;
}
//---------------------------------------------------------------------------
bool __fastcall TOptForm::SplitComm(AnsiString StartStr)
{
  int ASPos, CPos = 1, Temp;
  AnsiString TempComms[7];
  for (Temp = 1; Temp < 6; Temp++)               //Clear Comms array
   FComms[Temp] = "";

  if (StartStr.Length() == 0) return false;      //If no String
  StartStr.Trim();                               //Clear Spaces

  for (ASPos = 0; ASPos < StartStr.Length(); ASPos++) {
    if (StartStr.IsDelimiter("#", ASPos) == true) break;
    else if (StartStr.IsDelimiter(";", ASPos) == true) CPos++;
    else TempComms[CPos] += StartStr.c_str()[ASPos];
  }

  for (Temp = 1; Temp < 6; Temp++) {
    TempComms[Temp] = TempComms[Temp].Trim();
    FComms[Temp] = TempComms[Temp].SubString(1, TempComms[Temp].Length() - 1);
  }

  return true;
}
//---------------------------------------------------------------------------
void __fastcall TOptForm::ColourChange(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{
  ColorDiag->Color = ((TShape*)(Sender))->Brush->Color;

  if (ColorDiag->Execute()) {
    if (Sender == BackCl_S) BackCl = ColorDiag->Color;
    else if (Sender == FileCl_S) FileCl = ColorDiag->Color;
    else if (Sender == DirCl_S) DirCl = ColorDiag->Color;
    DisplayCustomSettings();
  }
}
//---------------------------------------------------------------------------





