//---------------------------------------------------------------------------
#ifndef OptionsH
#define OptionsH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ComCtrls.hpp>
#include <FStream.h>
#include <Buttons.hpp>
#include <IniFiles.hpp>
#include <Dialogs.hpp>
#include <ExtCtrls.hpp>
//---------------------------------------------------------------------------
class TOptForm : public TForm
{
__published:	// IDE-managed Components
        TPageControl *OptPageControl;
        TTabSheet *FileTypes_TS;
        TListView *ExtListView;
        TGroupBox *FTGroupBox;
        TLabel *FTInfo2_L;
        TEdit *FTDesc_E;
        TComboBox *FTOpen_CB;
        TLabel *FTInfo3_L;
        TBitBtn *Exit_B;
        TBitBtn *Save_B;
        TButton *FTRemove_B;
        TTabSheet *ProgLoc_TB;
        TLabel *PLInfo1_L;
        TLabel *PLInfo2_L;
        TLabel *PLInfo3_L;
        TLabel *PLInfo4_L;
        TLabel *PLInfo5_L;
        TEdit *Loc1_E;
        TEdit *Loc2_E;
        TEdit *Loc3_E;
        TEdit *Loc4_E;
        TEdit *Loc5_E;
        TTabSheet *Environ_TB;
        TFontDialog *FontDiag;
        TLabel *EnInfo1_L;
        TButton *ChFont_B;
        TLabel *EnInfo2_L;
        TLabel *EnInfo3_L;
        TLabel *EnInfo_4;
        TShape *BackCl_S;
        TShape *FileCl_S;
        TShape *DirCl_S;
        TColorDialog *ColorDiag;
        TButton *FTAdd_B;
        TLabel *FTInfo1_L;
        TEdit *FTExt_E;
        TEdit *FTIcFile_E;
        TEdit *FTIcNum_E;
        TLabel *FTInfo4_L;
        TLabel *FTInfo5_L;
        void __fastcall FormCreate(TObject *Sender);
        void __fastcall ExtListViewSelectItem(TObject *Sender,
          TListItem *Item, bool Selected);
        void __fastcall FTExtChange(TObject *Sender);
        void __fastcall MainButtonClick(TObject *Sender);
        void __fastcall ColourChange(TObject *Sender, TMouseButton Button,
          TShiftState Shift, int X, int Y);

private:  
  TColor BackCl;
  TColor FileCl;
  TColor DirCl;
  AnsiString FComms[7];
  int CurItemX;
  int CurItemY;
  int CurItemZ;

  void DisplayCustomSettings();
  void LoadExtensions(AnsiString RegFileName);
  void LoadOptions(AnsiString Loc);
  void NewExtension();
  void SaveExtensions(AnsiString FileName);
  void SaveOptions(AnsiString Loc);

public:		// User declarations
  AnsiString szDirectory;
  __fastcall TOptForm(TComponent* Owner);
  bool __fastcall SplitComm(AnsiString StartStr);
};
//---------------------------------------------------------------------------
extern PACKAGE TOptForm *OptForm;
//---------------------------------------------------------------------------
#endif
