//---------------------------------------------------------------------------
#ifndef PropertiesH
#define PropertiesH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ExtCtrls.hpp>
#include <ComCtrls.hpp>
#include <Chart.hpp>
#include <Series.hpp>
#include <TeEngine.hpp>
#include <TeeProcs.hpp>
#include <sys\\stat.h>
#include <Time.h>
//---------------------------------------------------------------------------
struct TFileInfo
{
  AnsiString sName;
  bool bReadOnly;
  bool bHidden;
  bool bSystem;
  bool bDirectory;
  bool bArchive;
};
struct TDiskInfo
{
  AnsiString sDrive;
  AnsiString sId;
};
//---------------------------------------------------------------------------
class TPropForm : public TForm
{
__published:	// IDE-managed Components
  TPageControl *PageControl;
  TTabSheet *FileProp;
  TLabel *FInfo1_L;
  TLabel *Report1_L;
  TLabel *FInfo2_L;
  TLabel *Report2_L;
  TLabel *Report3_L;
  TLabel *FInfo3_L;
  TLabel *FInfo4_L;
  TLabel *Report4_L;
  TLabel *FInfo5_L;
  TLabel *Report5_L;
  TLabel *Report6_L;
  TLabel *FInfo6_L;
  TLabel *Info7_L;
  TBevel *Bevel2;
  TBevel *Bevel1;
  TCheckBox *Archive_CB;
  TCheckBox *Hidden_CB;
  TCheckBox *System_CB;
  TCheckBox *ReadOnly_CB;
  TEdit *FileName_E;
  TButton *Ok_B;
  TButton *Cancel_B;
  TTabSheet *DriveProp;
  TLabel *DriveSize_L;
  TLabel *DriveFree_L;
  TLabel *DriveUsed_L;
  TLabel *DInfo1_L;
  TLabel *DInfo2_L;
  TLabel *DInfo3_L;
  TLabel *DInfo0_L;
  TEdit *DriveName_E;
  TChart *SpaceUsage;
  TPieSeries *Series1;
  TShape *DShape1;
  TShape *DShape2;
  TTabSheet *ToolsCtrl;
  TGroupBox *TInfo1_GB;
  TButton *Defrag_B;
  TLabel *TInfo1_L;
  TGroupBox *TInfo2_GB;
  TButton *ErrCheck_B;
  TLabel *TInfo2_L;
  TGroupBox *TInfo3_GB;
  TButton *Clean_B;
  TLabel *TInfo3_L;
  TTabSheet *DirProp;
  TEdit *IDirName_E;
  TLabel *IInfo1_L;
  TLabel *IFileType_L;
  TLabel *IInfo2_L;
  TLabel *ILocation_L;
  TLabel *IInfo3_L;
  TLabel *ISize_L;
  TBevel *IBevel1;
  TLabel *IInfo5_L;
  TLabel *ICreated_L;
  TLabel *IInfo4_L;
  TLabel *IContains_L;

  void __fastcall FormActivate(TObject *Sender);
  void __fastcall PButtonClick(TObject *Sender);
  void __fastcall ToolsButtonClick(TObject *Sender);
private:	// User declarations
  struct TFileInfo FFileInfo;
  struct TDiskInfo FDiskInfo;
  struct stat File_Stats;                        //File Stats Structure

  bool GetAttributes(AnsiString F_Name);
  bool GetFileStats(AnsiString F_Name);
  void __fastcall ShowDirectory();
  void __fastcall ShowDrive();
  void __fastcall ShowFile();

public:		// User declarations
  TViewTypes Mode;
  long double TotalDirSize;
  int NumDirectories;

  __fastcall TPropForm(TComponent* Owner);
  TStringList *__fastcall BasicFileSearch(const AnsiString Mask,
   AnsiString DirName, bool SearchSubDirectories);
  AnsiString __fastcall FormatTime(long FTime);

};
//---------------------------------------------------------------------------
extern PACKAGE TPropForm *PropForm;
//---------------------------------------------------------------------------
#endif
