//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "RegForm.h"
#include "FView.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TLearnForm *LearnForm;
//---------------------------------------------------------------------------
__fastcall TLearnForm::TLearnForm(TComponent* Owner)
        : TForm(Owner)
{
  RegLearn = new TRegLearn;
  CurExt_L->Caption = "";
  CurPos_L->Caption = "";
}
//---------------------------------------------------------------------------
__fastcall TLearnForm::~TLearnForm()
{
  delete RegLearn;
}
//---------------------------------------------------------------------------
void __fastcall TLearnForm::FormActivate(TObject *Sender)
{
  int Res = ID_YES;
  if (FileExists(MainForm->szDirectory + "RegInfo.ini")) {
    Res = Application->MessageBox("Relearn File Types?", "Reg Learn",
     MB_YESNO | MB_ICONQUESTION);
  }
  if (Res == ID_YES) {
    Close_B->Enabled = false;                    //Prevent user from closeing
    RegLearn->StartRead();                       //Start
    RegLearn->AddFVFileTypes();                  //Add Extra Supported types
    CurExt_L->Caption = "DONE!";                 //Say Finished
    Close_B->Enabled = true;
  }

  Close();
}
//---------------------------------------------------------------------------
__fastcall TRegLearn::TRegLearn()
{
  FReg = new TRegistry();                        //Registry Handle
  FReg->RootKey = HKEY_CLASSES_ROOT;             //Read ROOT Key ONLY
}
//---------------------------------------------------------------------------
__fastcall TRegLearn::~TRegLearn()
{
  if (FReg) delete FReg;
}
//---------------------------------------------------------------------------
void TRegLearn::AddFVFileTypes()
{
  AnsiString FileName = MainForm->szDirectory + "RegInfo.ini";
  ofstream File;

  File.open(FileName.c_str(), ios::app | ios::out);
  if (!File) return;

  File << ".BMP; Windows Bitmap; -; 0; 4;\n";
  File << ".CDA; CD Audio Track; C:\\WINDOWS\\cdplayer.exe; 1; 7;\n";
  File << ".EMF; Enhanced Meta File; -; 0; 4;\n";
  File << ".GIF; Compuserve Graphics Interchange; -; 0; 4;\n";
  File << ".INF; Setup Information; shell32.dll; 66; 3\n";
  File << ".INI; Configuration Settings; shell32.dll; 66; 3\n";
  File << ".JPG; JPEG Image; -; 0; 4;\n";
  File << ".JPE; JPEG Image; -; 0; 4;\n";
  File << ".TXT; Text Document; shell32.dll; 67; 4;\n";
  File << ".WMF; Windows Meta File; -; 0; 4;\n";
  File.close();
}
//---------------------------------------------------------------------------
bool TRegLearn::Find_Key(const bool Open, AnsiString Name)
{
  bool frrval;                                   //FReg Return Value
  frrval = FReg->KeyExists(Name);                //Check if Key Exists
  if ((frrval) && (Open)) FReg->OpenKey(Name, false);
  return frrval;
}
//---------------------------------------------------------------------------
void TRegLearn::Find_Program_Icon(AnsiString Name)
{
  AnsiString FullName;
  AnsiString IconNumber;
  int Temp;
  int Pos = 1;

  FIconLoc = "-";
  FIconNum = 0;

  if (Find_Key(true, Name + "\\DefaultIcon")) {
    FullName = Read_KeyStr("$default");

    if (FullName.Length() > 4) {
      while ((Pos < FullName.Length() && (FullName.IsDelimiter(",", Pos) == false))) Pos++;
      FIconLoc = FullName.SubString(1, Pos - 1);
      IconNumber = FullName.SubString(Pos + 1, FullName.Length());
      if (IconNumber.Length() > 0) FIconNum = IconNumber.ToInt();
      if (FIconNum < 0) {
        if (FIconNum == -151) FIconNum = 66;
        else if (FIconNum == -152) FIconNum = 67;
        else if (FIconNum == -153) FIconNum = 68;
        else if (FIconNum == -154) FIconNum = 69;
        else if (FIconNum == -155) FIconNum = 70;
        else if (FIconNum == -156) FIconNum = 71;
        else FIconNum = abs(FIconNum);//If minus turn to pos
      }
    }
  }
  //FReg->CloseKey();
}
//---------------------------------------------------------------------------
int TRegLearn::GetRunType(AnsiString E)
{
  int RT;
  if (E == ".BMP") RT = 4;
  else if (E == ".CDA") RT = 2;
  else if (E == ".EMF") RT = 4;
  else if (E == ".GIF") RT = 4;
  else if (E == ".INF") RT = 3;
  else if (E == ".INI") RT = 3;
  else if (E == ".JPG") RT = 4;
  else if (E == ".JPE") RT = 4;
  else if (E == ".TXT") RT = 3;
  else if (E == ".WMF") RT = 4;
  else RT = 1;

  return RT;
}
//---------------------------------------------------------------------------
AnsiString TRegLearn::Read_KeyStr(AnsiString Name)
{
  /**************************************************/
  /*Default String can be passed as "" or "$default"*/
  /**************************************************/
  if (Name == "$default") Name = "";
  return FReg->ReadString(Name);                 //Read the String
}
//---------------------------------------------------------------------------
bool TRegLearn::Search_Ext(AnsiString Ext)
{
  AnsiString Value;

  FDesc = "-";

  if (Find_Key(true, Ext) == false) return false;
  else {                                         //Key Found
    Value = Read_KeyStr("$default");             //Read Default
    FReg->CloseKey();
    if (Value.Length() == 0) return false;
    else {
      FDesc = Value;
      if (Find_Key(true, FDesc) == true) {
        Value = Read_KeyStr("$default");
        FReg->CloseKey();
        Find_Program_Icon(FDesc);                //Find the Icon
        FReg->CloseKey();
        if (Value.Length() != 0) FDesc = Value;
      }
    }
  }

  return true;
}
//---------------------------------------------------------------------------
void TRegLearn::StartRead()
{
  AnsiString Ext;
  AnsiString Res;
  AnsiString FileName;
  int W, X, Y;

  float Count = 0;
  FileName = MainForm->szDirectory + "RegInfo.ini";
  ofstream File(FileName.c_str());               //Open file
  if (!File) {
    ShowMessage("Can't open RegInfo.ini");
    return;
  }
  File << "FV41" << endl;                        //4CC

  for (W = 48; W < 91; W++) {
    for (X = 32; X < 91; X++) {
      for (Y = 32; Y < 91; Y++) {
        Count++;
        Ext = ".";
        Ext += char(W);
        Ext += char(X);
        Ext += char(Y);

        if (Search_Ext(Ext)) {                   //Search for Extension
          FRunType = GetRunType(Ext);
          LearnForm->CurExt_L->Caption = Ext + " " + FDesc; //Show current extension

          if (FRunType == 1) {
            File << Ext.c_str() << "; ";         //Save to file
            File << FDesc.c_str() << "; ";
            File << FIconLoc.c_str() << "; ";
            File << FIconNum << "; ";
            File << FRunType << ";" << endl;
          }
        }
      }
      LearnForm->ProgressBar->Position = (Count / 149683) * 100;
      LearnForm->CurPos_L->Caption = FloatToStrF(((Count / 149683.0f) * 100.0f), ffFixed, 8, 0) + "%";
      Application->ProcessMessages();
      //cprintf("%0.0f Percent Complete", (Count / 149683) * 100);
    }
  }
  File.close();                                  //Close File
}
//---------------------------------------------------------------------------

void __fastcall TLearnForm::Close_BClick(TObject *Sender)
{
  Close();
}
//---------------------------------------------------------------------------

