//---------------------------------------------------------------------------
#include <vcl.h>
#include "RegUnit.h"
#pragma hdrstop
//---------------------------------------------------------------------------
RegLearn *TRegLearn;
//---------------------------------------------------------------------------
int main()
{
  TRegLearn = new RegLearn;
  clrscr();
  textbackground(0);
  textcolor(14);
  gotoxy(1, 1);
  cprintf("Learning file extensions\n");
  textcolor(12);
  gotoxy(1, 4);
  cprintf("This program only Runs ONCE, so please be patient");

  TRegLearn->StartRead();

  textcolor(15);
  gotoxy(1, 11);
  cprintf("DONE!");
  gotoxy(1, 12);
  cprintf("Press any key to continue...");
  getch();
  return 0;
}
//---------------------------------------------------------------------------
__fastcall RegLearn::RegLearn()
{
  FReg = new TRegistry();                        //Registry Handle
  FReg->RootKey = HKEY_CLASSES_ROOT;             //Read ROOT Key ONLY
}
//---------------------------------------------------------------------------
__fastcall RegLearn::~RegLearn()
{
  if (FReg) delete FReg;
}
//---------------------------------------------------------------------------
bool RegLearn::Find_Key(const bool Open, AnsiString Name)
{
  bool frrval;                                   //FReg Return Value
  frrval = FReg->KeyExists(Name);                //Check if Key Exists
  if ((frrval) && (Open)) FReg->OpenKey(Name, false);
  return frrval;
}
//---------------------------------------------------------------------------
void RegLearn::Find_Program_Icon(AnsiString Name)
{
  AnsiString FullName;
  AnsiString IconNumber;
  int Temp;
  int Pos = 1;

  FIconLoc = "-";
  FIconNum = 0;

  if (Find_Key(true, Name + "\\DefaultIcon")) {
    FullName = Read_KeyStr("$default");

    if (FullName.Length() > 4) {
      while ((Pos < FullName.Length() && (FullName.IsDelimiter(",", Pos) == false))) Pos++;
      FIconLoc = FullName.SubString(1, Pos - 1);
      IconNumber = FullName.SubString(Pos + 1, FullName.Length());
      if (IconNumber.Length() > 0) FIconNum = IconNumber.ToInt();
      if (FIconNum < 0) {
        if (FIconNum == -151) FIconNum = 66;
        else if (FIconNum == -152) FIconNum = 67;
        else if (FIconNum == -153) FIconNum = 68;
        else if (FIconNum == -154) FIconNum = 69;
        else if (FIconNum == -155) FIconNum = 70;
        else if (FIconNum == -156) FIconNum = 71;
        else FIconNum = abs(FIconNum);//If minus turn to pos
      }
    }
  }
  //FReg->CloseKey();
}
//---------------------------------------------------------------------------
int RegLearn::GetRunType(AnsiString E)
{
  int RT;
  if (E == ".BMP") RT = 4;
  else if (E == ".EMF") RT = 4;
  else if (E == ".GIF") RT = 4;
  else if (E == ".INF") RT = 3;
  else if (E == ".INI") RT = 3;
  else if (E == ".JPG") RT = 4;
  else if (E == ".JPE") RT = 4;
  else if (E == ".TXT") RT = 3;
  else if (E == ".WMF") RT = 4;
  else RT = 1;

  return RT;
}
//---------------------------------------------------------------------------
AnsiString RegLearn::Read_KeyStr(AnsiString Name)
{
  /**************************************************/
  /*Default String can be passed as "" or "$default"*/
  /**************************************************/
  if (Name == "$default") Name = "";
  return FReg->ReadString(Name);                 //Read the String
}
//---------------------------------------------------------------------------
bool RegLearn::Search_Ext(AnsiString Ext)
{
  AnsiString Value;

  FDesc = "-";

  if (Find_Key(true, Ext) == false) return false;
  else {                                         //Key Found
    Value = Read_KeyStr("$default");             //Read Default
    FReg->CloseKey();
    if (Value.Length() == 0) return false;
    else {
      FDesc = Value;
      if (Find_Key(true, FDesc) == true) {
        Value = Read_KeyStr("$default");
        FReg->CloseKey();
        Find_Program_Icon(FDesc);                //Find the Icon
        FReg->CloseKey();
        if (Value.Length() != 0) FDesc = Value;
      }
    }
  }

  return true;
}
//---------------------------------------------------------------------------
void RegLearn::StartRead()
{
  AnsiString Ext;
  AnsiString Res;
  int W, X, Y;
  float Count = 0;
  ofstream File("RegInfo.ini");                  //Open file
  if (!File) {
    cout << "Can't open RegInfo.ini" << endl;
    return;
  }
  File << "FV41" << endl;                        //4CC

  textcolor(9);

  for (W = 48; W < 91; W++) {
    for (X = 32; X < 91; X++) {
      for (Y = 32; Y < 91; Y++) {
        Count++;
        Ext = ".";
        Ext += char(W);
        Ext += char(X);
        Ext += char(Y);

        if (Search_Ext(Ext)) {                   //Search for Extension
          FRunType = GetRunType(Ext);
          gotoxy(1, 9);                          //Show current extension
          clreol();
          cprintf("%s %s", Ext.c_str(), FDesc.c_str());

          File << Ext.c_str() << "; ";           //Save to file
          File << FDesc.c_str() << "; ";
          File << FIconLoc.c_str() << "; ";
          File << FIconNum << "; ";
          File << FRunType << ";" << endl;
        }
      }
      gotoxy(1, 7);                              //Show percentage complete
      cprintf("%0.0f Percent Complete", (Count / 149683) * 100);
    }
  }
  File.close();                                  //Close File
}
//---------------------------------------------------------------------------
